Summary: GNU Ada 95 Translator
Name: gnat
Version: 3.10p
Release: 3
%define gccversion 2.7.2.3
Source0: ftp://cs.nyu.edu/pub/gnat/gnat-3.10p-src.tar.gz
Source1: ftp://ftp.gnu.org/pub/gnu/gcc-%{gccversion}.tar.gz
Source2: ftp://cs.nyu.edu/pub/gnat/gnat-3.10p-docs.tar.gz
Source3: ftp://cs.nyu.edu/pub/gnat/gnat-3.10p-i386-linux-bin.tar.gz
Patch0: gnat-3.10p-sigset_t.patch
Patch1: gnat-3.10p-NULL.patch
Patch2: gnat-3.10p-gnatgcc.patch
Patch3: gnat-3.10p-libsubdir.patch
Copyright: GNU
Group: Development/Languages
Buildroot: /var/tmp/gnat-%{PACKAGE_VERSION}-root
Url: http://www.gnat.com/
Requires: binutils
Prereq: /sbin/install-info
Exclusivearch: i386

%description
GNAT is the GNU Ada 95 Translator.  It includes a revised
driver (gnatgcc) with Ada support, as well as appropriate
utilities and compilers.

%package docs
Summary: GNAT extra documentation
Group: Development/Languages

%description docs
GNAT documentation in alternative flavors: texinfo, html,
PostScript, and plain text.  The compiled info files are
included in the main GNAT rpm.

%prep
%setup -q -n gnat-%{PACKAGE_VERSION}-src -a 1 -a 2 -a 3
mv src/ada gcc-%{gccversion}
cd gcc-%{gccversion}
patch -p0 < ../src/gcc-2721.dif 
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
cd gcc-%{gccversion}

# Speed this up if we can
numprocs=`grep -c ^processor /proc/cpuinfo | awk '{print $1*2}'`
if [ "0$numprocs" -gt 0 ]; then
    MAKE="make -j$numprocs"
else
    MAKE="make"
fi

# Make the original gcc
./configure --prefix=/usr $RPM_ARCH-redhat-linux
touch ada/{treeprs.ads,a-[es]info.h,nmake.ad[bs]}
$MAKE CFLAGS="$RPM_OPT_FLAGS" LANGUAGES="c"

# Make with the mixed compiler
make stage1
mv ../gnat-3.10p-i386-linux-bin/{gnat*,xgcc} stage1
$MAKE CC="`pwd`/stage1/xgcc -B`pwd`/stage1/" \
    GNATCC="`pwd`/stage1/xgcc -B`pwd`/stage1/" \
    STAGE_PREFIX="`pwd`/stage1/" \
    CFLAGS="$RPM_OPT_FLAGS" LANGUAGES="c ada"

# Make with self
make stage2
$MAKE CC="`pwd`/stage2/xgcc -B`pwd`/stage2/" \
    GNATCC="`pwd`/stage2/xgcc -B`pwd`/stage2/" \
    STAGE_PREFIX="`pwd`/stage2/" \
    CFLAGS="$RPM_OPT_FLAGS" LANGUAGES="c ada"
# (don't try to do this with "make -j"; it sometimes fails)
make CC="`pwd`/stage2/xgcc -B`pwd`/stage2/" \
    GNATCC="`pwd`/stage2/xgcc -B`pwd`/stage2/" \
    STAGE_PREFIX="`pwd`/stage2/" \
    CFLAGS="$RPM_OPT_FLAGS" LANGUAGES="c ada" \
    gnatlib_and_tools

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

# Install the compiler and gnat manual pages
cd gcc-%{gccversion}
make install \
    LANGUAGES="ada" \
    prefix=$RPM_BUILD_ROOT/usr \
    MAKEINFO="makeinfo --no-split"
rm -rf $RPM_BUILD_ROOT/usr/man/man1
mkdir -p $RPM_BUILD_ROOT/usr/man/man1
install -m 644 ada/*.1 $RPM_BUILD_ROOT/usr/man/man1
cd $RPM_BUILD_ROOT/usr/bin
mv gcc gnatgcc
mv $RPM_ARCH-redhat-linux-gcc $RPM_ARCH-redhat-linux-gnatgcc
cd ../lib/gnat-lib/$RPM_ARCH-redhat-linux/%{gccversion}

# Install the gnat info files
cd $RPM_BUILD_DIR/gnat-%{PACKAGE_VERSION}-src/gnat-%{PACKAGE_VERSION}-docs
rm -rf $RPM_BUILD_ROOT/usr/info 
mkdir $RPM_BUILD_ROOT/usr/info
install -m 644 *.info *.info-[0-9] $RPM_BUILD_ROOT/usr/info
gzip -n -9f $RPM_BUILD_ROOT/usr/info/*

# 3 megs of extra documentation
mv *.{html,ps,texi,txt} ..

%files
%defattr(-,root,root)
%doc README examples features gnatinfo.txt
%doc gnat_{rm,ug}.*
%doc /usr/info/*
%doc /usr/man/*/*
/usr/bin/*
/usr/lib/gnat-lib

%files docs
%defattr(644,root,root)
%doc *.{html,ps,texi,txt}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/install-info \
    --section="Programming:" \
    --entry="* gnat_ug: (gnat_ug)		GNAT User's Guide." \
    --info-dir=/usr/info /usr/info/gnat_ug.info.gz
/sbin/install-info \
    --section="Programming:" \
    --entry="* gnat_rm: (gnat_rm)		GNAT Reference Manual." \
    --info-dir=/usr/info /usr/info/gnat_rm.info.gz

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete --info-dir=/usr/info /usr/info/gnat_ug.info.gz
    /sbin/install-info --delete --info-dir=/usr/info /usr/info/gnat_rm.info.gz
fi

%changelog
* Tue Dec 15 1998 Aron Griffis <agriffis@css.tayloru.edu> [3.10p-3]
- fixed problem of needing both libgcc.a and libgnatgcc.a; 
  removed symbolic link hack
- fixed bug which prevented build without pre-installed gnat
  (STAGE_PREFIX for gnatbind)

* Tue Dec 15 1998 Aron Griffis <agriffis@css.tayloru.edu> [3.10p-2]
- fixed race condition building gnatlib_and_tools by not using "make -j"
  for that portion of the build

* Sun Dec 13 1998 Aron Griffis <agriffis@bigfoot.com> [3.10p-1]
- created initial packages
- driver is installed as gnatgcc; library files are in /usr/lib/gnat-lib/...
- includes glibc sigset_t patch
- thanks to Rich Pinkall-Pollei and Mark W. Eichin for ideas
